// Auto-generated. Do not edit!

// (in-package gcloud_speech_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;

//-----------------------------------------------------------

class RecognitionHypothesis {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.transcript = null;
      this.confidence = null;
    }
    else {
      if (initObj.hasOwnProperty('transcript')) {
        this.transcript = initObj.transcript
      }
      else {
        this.transcript = '';
      }
      if (initObj.hasOwnProperty('confidence')) {
        this.confidence = initObj.confidence
      }
      else {
        this.confidence = 0.0;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type RecognitionHypothesis
    // Serialize message field [transcript]
    bufferOffset = _serializer.string(obj.transcript, buffer, bufferOffset);
    // Serialize message field [confidence]
    bufferOffset = _serializer.float64(obj.confidence, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type RecognitionHypothesis
    let len;
    let data = new RecognitionHypothesis(null);
    // Deserialize message field [transcript]
    data.transcript = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [confidence]
    data.confidence = _deserializer.float64(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += object.transcript.length;
    return length + 12;
  }

  static datatype() {
    // Returns string type for a message object
    return 'gcloud_speech_msgs/RecognitionHypothesis';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '67d30fae26a67ab503aad1ca2f76d58e';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # Recognition hypothesis for a portion of speech. Equivalent to
    # google.cloud.speech.v1.SpeechRecognitionAlternative, See also:
    # https://cloud.google.com/speech/reference/rpc/google.cloud.speech.v1#speechrecognitionalternative
    
    # Transcript text representing the words that the user spoke.
    string transcript
    
    # The confidence estimate between 0.0 and 1.0. A higher number indicates an
    # estimated greater likelihood that the recognized words are correct. This field
    # is typically provided only for the top hypothesis, and only for
    # is_portion_final=true results. Clients should not rely on the confidence field
    # as it is not guaranteed to be accurate or consistent. The default of 0.0 is a
    # sentinel value indicating confidence was not set.
    float64 confidence
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new RecognitionHypothesis(null);
    if (msg.transcript !== undefined) {
      resolved.transcript = msg.transcript;
    }
    else {
      resolved.transcript = ''
    }

    if (msg.confidence !== undefined) {
      resolved.confidence = msg.confidence;
    }
    else {
      resolved.confidence = 0.0
    }

    return resolved;
    }
};

module.exports = RecognitionHypothesis;
