// Auto-generated. Do not edit!

// (in-package gcloud_speech_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let SpeechToTextFeedback = require('./SpeechToTextFeedback.js');
let actionlib_msgs = _finder('actionlib_msgs');
let std_msgs = _finder('std_msgs');

//-----------------------------------------------------------

class SpeechToTextActionFeedback {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.header = null;
      this.status = null;
      this.feedback = null;
    }
    else {
      if (initObj.hasOwnProperty('header')) {
        this.header = initObj.header
      }
      else {
        this.header = new std_msgs.msg.Header();
      }
      if (initObj.hasOwnProperty('status')) {
        this.status = initObj.status
      }
      else {
        this.status = new actionlib_msgs.msg.GoalStatus();
      }
      if (initObj.hasOwnProperty('feedback')) {
        this.feedback = initObj.feedback
      }
      else {
        this.feedback = new SpeechToTextFeedback();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type SpeechToTextActionFeedback
    // Serialize message field [header]
    bufferOffset = std_msgs.msg.Header.serialize(obj.header, buffer, bufferOffset);
    // Serialize message field [status]
    bufferOffset = actionlib_msgs.msg.GoalStatus.serialize(obj.status, buffer, bufferOffset);
    // Serialize message field [feedback]
    bufferOffset = SpeechToTextFeedback.serialize(obj.feedback, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type SpeechToTextActionFeedback
    let len;
    let data = new SpeechToTextActionFeedback(null);
    // Deserialize message field [header]
    data.header = std_msgs.msg.Header.deserialize(buffer, bufferOffset);
    // Deserialize message field [status]
    data.status = actionlib_msgs.msg.GoalStatus.deserialize(buffer, bufferOffset);
    // Deserialize message field [feedback]
    data.feedback = SpeechToTextFeedback.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += std_msgs.msg.Header.getMessageSize(object.header);
    length += actionlib_msgs.msg.GoalStatus.getMessageSize(object.status);
    length += SpeechToTextFeedback.getMessageSize(object.feedback);
    return length;
  }

  static datatype() {
    // Returns string type for a message object
    return 'gcloud_speech_msgs/SpeechToTextActionFeedback';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'a40198c58431f079fecf571bc139e212';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======
    
    Header header
    actionlib_msgs/GoalStatus status
    SpeechToTextFeedback feedback
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    # 0: no frame
    # 1: global frame
    string frame_id
    
    ================================================================================
    MSG: actionlib_msgs/GoalStatus
    GoalID goal_id
    uint8 status
    uint8 PENDING         = 0   # The goal has yet to be processed by the action server
    uint8 ACTIVE          = 1   # The goal is currently being processed by the action server
    uint8 PREEMPTED       = 2   # The goal received a cancel request after it started executing
                                #   and has since completed its execution (Terminal State)
    uint8 SUCCEEDED       = 3   # The goal was achieved successfully by the action server (Terminal State)
    uint8 ABORTED         = 4   # The goal was aborted during execution by the action server due
                                #    to some failure (Terminal State)
    uint8 REJECTED        = 5   # The goal was rejected by the action server without being processed,
                                #    because the goal was unattainable or invalid (Terminal State)
    uint8 PREEMPTING      = 6   # The goal received a cancel request after it started executing
                                #    and has not yet completed execution
    uint8 RECALLING       = 7   # The goal received a cancel request before it started executing,
                                #    but the action server has not yet confirmed that the goal is canceled
    uint8 RECALLED        = 8   # The goal received a cancel request before it started executing
                                #    and was successfully cancelled (Terminal State)
    uint8 LOST            = 9   # An action client can determine that a goal is LOST. This should not be
                                #    sent over the wire by an action server
    
    #Allow for the user to associate a string with GoalStatus for debugging
    string text
    
    
    ================================================================================
    MSG: actionlib_msgs/GoalID
    # The stamp should store the time at which this goal was requested.
    # It is used by an action server when it tries to preempt all
    # goals that were requested before a certain time
    time stamp
    
    # The id provides a way to associate feedback and
    # result message with specific goal requests. The id
    # specified must be unique.
    string id
    
    
    ================================================================================
    MSG: gcloud_speech_msgs/SpeechToTextFeedback
    # ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======
    
    
    # Feedback definition: users should mostly rely on these feedbacks to get
    # recognition results.
    # Equivalent to google.cloud.speech.v1.StreamingRecognitionResult. See also:
    # https://cloud.google.com/speech/reference/rpc/google.cloud.speech.v1#speechrecognitionresult
    
    # Transcript text representing the words that the user spoke. The length of this
    # array is equal to the following "confidence" array.
    gcloud_speech_msgs/RecognitionHypothesis[] hypotheses
    
    # If false, this SpeechToTextFeedback represents an interim result that may
    # change. If true, the recognizer will not return any further hypotheses for
    # this portion of the transcript and corresponding audio as
    # SpeechToTextFeedback.
    bool is_portion_final
    
    # An estimate of the likelihood that the recognizer will not change its guess
    # about this interim result. Values range from 0.0 (completely unstable) to
    # 1.0 (completely stable). This field is only provided for interim results
    # (is_portion_final=false). The default of 0.0 is a sentinel value indicating
    # stability was not set.
    float64 stability
    
    
    ================================================================================
    MSG: gcloud_speech_msgs/RecognitionHypothesis
    # Recognition hypothesis for a portion of speech. Equivalent to
    # google.cloud.speech.v1.SpeechRecognitionAlternative, See also:
    # https://cloud.google.com/speech/reference/rpc/google.cloud.speech.v1#speechrecognitionalternative
    
    # Transcript text representing the words that the user spoke.
    string transcript
    
    # The confidence estimate between 0.0 and 1.0. A higher number indicates an
    # estimated greater likelihood that the recognized words are correct. This field
    # is typically provided only for the top hypothesis, and only for
    # is_portion_final=true results. Clients should not rely on the confidence field
    # as it is not guaranteed to be accurate or consistent. The default of 0.0 is a
    # sentinel value indicating confidence was not set.
    float64 confidence
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new SpeechToTextActionFeedback(null);
    if (msg.header !== undefined) {
      resolved.header = std_msgs.msg.Header.Resolve(msg.header)
    }
    else {
      resolved.header = new std_msgs.msg.Header()
    }

    if (msg.status !== undefined) {
      resolved.status = actionlib_msgs.msg.GoalStatus.Resolve(msg.status)
    }
    else {
      resolved.status = new actionlib_msgs.msg.GoalStatus()
    }

    if (msg.feedback !== undefined) {
      resolved.feedback = SpeechToTextFeedback.Resolve(msg.feedback)
    }
    else {
      resolved.feedback = new SpeechToTextFeedback()
    }

    return resolved;
    }
};

module.exports = SpeechToTextActionFeedback;
