// Auto-generated. Do not edit!

// (in-package gcloud_speech_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let SpeechToTextGoal = require('./SpeechToTextGoal.js');
let actionlib_msgs = _finder('actionlib_msgs');
let std_msgs = _finder('std_msgs');

//-----------------------------------------------------------

class SpeechToTextActionGoal {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.header = null;
      this.goal_id = null;
      this.goal = null;
    }
    else {
      if (initObj.hasOwnProperty('header')) {
        this.header = initObj.header
      }
      else {
        this.header = new std_msgs.msg.Header();
      }
      if (initObj.hasOwnProperty('goal_id')) {
        this.goal_id = initObj.goal_id
      }
      else {
        this.goal_id = new actionlib_msgs.msg.GoalID();
      }
      if (initObj.hasOwnProperty('goal')) {
        this.goal = initObj.goal
      }
      else {
        this.goal = new SpeechToTextGoal();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type SpeechToTextActionGoal
    // Serialize message field [header]
    bufferOffset = std_msgs.msg.Header.serialize(obj.header, buffer, bufferOffset);
    // Serialize message field [goal_id]
    bufferOffset = actionlib_msgs.msg.GoalID.serialize(obj.goal_id, buffer, bufferOffset);
    // Serialize message field [goal]
    bufferOffset = SpeechToTextGoal.serialize(obj.goal, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type SpeechToTextActionGoal
    let len;
    let data = new SpeechToTextActionGoal(null);
    // Deserialize message field [header]
    data.header = std_msgs.msg.Header.deserialize(buffer, bufferOffset);
    // Deserialize message field [goal_id]
    data.goal_id = actionlib_msgs.msg.GoalID.deserialize(buffer, bufferOffset);
    // Deserialize message field [goal]
    data.goal = SpeechToTextGoal.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += std_msgs.msg.Header.getMessageSize(object.header);
    length += actionlib_msgs.msg.GoalID.getMessageSize(object.goal_id);
    length += SpeechToTextGoal.getMessageSize(object.goal);
    return length;
  }

  static datatype() {
    // Returns string type for a message object
    return 'gcloud_speech_msgs/SpeechToTextActionGoal';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '6175e2e8b986c5e017d26c349a3f49c4';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======
    
    Header header
    actionlib_msgs/GoalID goal_id
    SpeechToTextGoal goal
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    # 0: no frame
    # 1: global frame
    string frame_id
    
    ================================================================================
    MSG: actionlib_msgs/GoalID
    # The stamp should store the time at which this goal was requested.
    # It is used by an action server when it tries to preempt all
    # goals that were requested before a certain time
    time stamp
    
    # The id provides a way to associate feedback and
    # result message with specific goal requests. The id
    # specified must be unique.
    string id
    
    
    ================================================================================
    MSG: gcloud_speech_msgs/SpeechToTextGoal
    # ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======
    # Goal definition
    # Equivalent to google.cloud.speech.v1.StreamingRecognitionConfig. See also:
    # https://cloud.google.com/speech/reference/rpc/google.cloud.speech.v1#streamingrecognitionconfig
    
    # A list of strings containing words and phrases "hints" so that the speech
    # recognition is more likely to recognize them. This can be used to improve the
    # accuracy for specific words and phrases, for example, if specific commands are
    # typically spoken by the user. This can also be used to add additional words to
    # the vocabulary of the recognizer.
    string[] hints
    
    # Maximum number of recognition hypotheses to be returned. Specifically, the
    # maximum number of RecognitionHypothesis messages within each
    # SpeechToTextFeedback. The server may return fewer than max_alternatives. Valid
    # values are 0-30. A value of 0 or 1 will return a maximum of one. If omitted,
    # will return a maximum of one.
    int32 max_alternatives
    
    # Maximum listening duration. The recognizer will start listening immediately,
    # and will stop listening after "listen_duration_sec" seconds. If 0 or omitted,
    # will use an internal default value (14 seconds).
    int32 listen_duration_sec
    
    # Maximum recognition duration. The recognizer will start counting down
    # immediately, and after max_recognition_duration_sec seconds it will return no
    # matter whether there is a recognition result. If 0 or omitted, will use
    # a default value: listen_duration_sec + 2.
    int32 max_recognition_duration_sec
    
    
    # If false or omitted, interim results (tentative hypotheses) may be returned as
    # they become available (these interim results are indicated with the
    # is_portion_final=false flag). If true, only is_portion_final=true result(s)
    # are returned.
    bool suppress_interim_results
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new SpeechToTextActionGoal(null);
    if (msg.header !== undefined) {
      resolved.header = std_msgs.msg.Header.Resolve(msg.header)
    }
    else {
      resolved.header = new std_msgs.msg.Header()
    }

    if (msg.goal_id !== undefined) {
      resolved.goal_id = actionlib_msgs.msg.GoalID.Resolve(msg.goal_id)
    }
    else {
      resolved.goal_id = new actionlib_msgs.msg.GoalID()
    }

    if (msg.goal !== undefined) {
      resolved.goal = SpeechToTextGoal.Resolve(msg.goal)
    }
    else {
      resolved.goal = new SpeechToTextGoal()
    }

    return resolved;
    }
};

module.exports = SpeechToTextActionGoal;
