// Auto-generated. Do not edit!

// (in-package gcloud_speech_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let RecognitionHypothesis = require('./RecognitionHypothesis.js');

//-----------------------------------------------------------

class SpeechToTextFeedback {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.hypotheses = null;
      this.is_portion_final = null;
      this.stability = null;
    }
    else {
      if (initObj.hasOwnProperty('hypotheses')) {
        this.hypotheses = initObj.hypotheses
      }
      else {
        this.hypotheses = [];
      }
      if (initObj.hasOwnProperty('is_portion_final')) {
        this.is_portion_final = initObj.is_portion_final
      }
      else {
        this.is_portion_final = false;
      }
      if (initObj.hasOwnProperty('stability')) {
        this.stability = initObj.stability
      }
      else {
        this.stability = 0.0;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type SpeechToTextFeedback
    // Serialize message field [hypotheses]
    // Serialize the length for message field [hypotheses]
    bufferOffset = _serializer.uint32(obj.hypotheses.length, buffer, bufferOffset);
    obj.hypotheses.forEach((val) => {
      bufferOffset = RecognitionHypothesis.serialize(val, buffer, bufferOffset);
    });
    // Serialize message field [is_portion_final]
    bufferOffset = _serializer.bool(obj.is_portion_final, buffer, bufferOffset);
    // Serialize message field [stability]
    bufferOffset = _serializer.float64(obj.stability, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type SpeechToTextFeedback
    let len;
    let data = new SpeechToTextFeedback(null);
    // Deserialize message field [hypotheses]
    // Deserialize array length for message field [hypotheses]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.hypotheses = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.hypotheses[i] = RecognitionHypothesis.deserialize(buffer, bufferOffset)
    }
    // Deserialize message field [is_portion_final]
    data.is_portion_final = _deserializer.bool(buffer, bufferOffset);
    // Deserialize message field [stability]
    data.stability = _deserializer.float64(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    object.hypotheses.forEach((val) => {
      length += RecognitionHypothesis.getMessageSize(val);
    });
    return length + 13;
  }

  static datatype() {
    // Returns string type for a message object
    return 'gcloud_speech_msgs/SpeechToTextFeedback';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '9d51422b863c8960964654dda15131a8';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======
    
    
    # Feedback definition: users should mostly rely on these feedbacks to get
    # recognition results.
    # Equivalent to google.cloud.speech.v1.StreamingRecognitionResult. See also:
    # https://cloud.google.com/speech/reference/rpc/google.cloud.speech.v1#speechrecognitionresult
    
    # Transcript text representing the words that the user spoke. The length of this
    # array is equal to the following "confidence" array.
    gcloud_speech_msgs/RecognitionHypothesis[] hypotheses
    
    # If false, this SpeechToTextFeedback represents an interim result that may
    # change. If true, the recognizer will not return any further hypotheses for
    # this portion of the transcript and corresponding audio as
    # SpeechToTextFeedback.
    bool is_portion_final
    
    # An estimate of the likelihood that the recognizer will not change its guess
    # about this interim result. Values range from 0.0 (completely unstable) to
    # 1.0 (completely stable). This field is only provided for interim results
    # (is_portion_final=false). The default of 0.0 is a sentinel value indicating
    # stability was not set.
    float64 stability
    
    
    ================================================================================
    MSG: gcloud_speech_msgs/RecognitionHypothesis
    # Recognition hypothesis for a portion of speech. Equivalent to
    # google.cloud.speech.v1.SpeechRecognitionAlternative, See also:
    # https://cloud.google.com/speech/reference/rpc/google.cloud.speech.v1#speechrecognitionalternative
    
    # Transcript text representing the words that the user spoke.
    string transcript
    
    # The confidence estimate between 0.0 and 1.0. A higher number indicates an
    # estimated greater likelihood that the recognized words are correct. This field
    # is typically provided only for the top hypothesis, and only for
    # is_portion_final=true results. Clients should not rely on the confidence field
    # as it is not guaranteed to be accurate or consistent. The default of 0.0 is a
    # sentinel value indicating confidence was not set.
    float64 confidence
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new SpeechToTextFeedback(null);
    if (msg.hypotheses !== undefined) {
      resolved.hypotheses = new Array(msg.hypotheses.length);
      for (let i = 0; i < resolved.hypotheses.length; ++i) {
        resolved.hypotheses[i] = RecognitionHypothesis.Resolve(msg.hypotheses[i]);
      }
    }
    else {
      resolved.hypotheses = []
    }

    if (msg.is_portion_final !== undefined) {
      resolved.is_portion_final = msg.is_portion_final;
    }
    else {
      resolved.is_portion_final = false
    }

    if (msg.stability !== undefined) {
      resolved.stability = msg.stability;
    }
    else {
      resolved.stability = 0.0
    }

    return resolved;
    }
};

module.exports = SpeechToTextFeedback;
